<?php
class ControllerExtensionPaymentCryptexy extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/payment/cryptexy');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('cryptexy', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true));
        }
        $data['heading_title'] = $this->language->get('heading_title');

        $data['text_edit'] = $this->language->get('text_edit');
        $data['text_enabled'] = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');
        $data['text_all_zones'] = $this->language->get('text_all_zones');
        $data['text_yes'] = $this->language->get('text_yes');
        $data['text_no'] = $this->language->get('text_no');
        $data['text_authorization'] = $this->language->get('text_authorization');
        $data['text_clear_log_success'] = $this->language->get('text_clear_log_success');

        $data['entry_log'] = $this->language->get('entry_log');
        $data['entry_api_key'] = $this->language->get('entry_api_key');
        $data['entry_debug'] = $this->language->get('entry_debug');
        $data['entry_total'] = $this->language->get('entry_total');
        $data['entry_completed_status'] = $this->language->get('entry_completed_status');
        $data['entry_less_status'] = $this->language->get('entry_less_status');
        $data['entry_more_status'] = $this->language->get('entry_more_status');
        $data['entry_failed_status'] = $this->language->get('entry_failed_status');
        $data['entry_pending_status'] = $this->language->get('entry_pending_status');
        $data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
        $data['entry_status'] = $this->language->get('entry_status');
        $data['entry_sort_order'] = $this->language->get('entry_sort_order');

        $data['help_test'] = $this->language->get('help_test');
        $data['help_debug'] = $this->language->get('help_debug');
        $data['help_total'] = $this->language->get('help_total');
        $data['text_confirm'] = $this->language->get('text_confirm');
        $data['log_filename'] = 'cryptexy.log';
        $data['log_lines']  = $this->readLastLines(DIR_LOGS . $data['log_filename'], 500);
        $data['clear_log']  = str_replace('&amp;', '&', $this->url->link('extension/payment/cryptexy/clearlog', 'token=' . $this->session->data['token'], true));

        $data['button_clear'] = $this->language->get('button_clear');
        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        $data['tab_general'] = $this->language->get('tab_general');
        $data['tab_order_status'] = $this->language->get('tab_order_status');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['api_key'])) {
			$data['error_api_key'] = $this->error['api_key'];
		} else {
			$data['error_api_key'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/cryptexy', 'token=' . $this->session->data['token'], true)
		);



		$data['action'] = $this->url->link('extension/payment/cryptexy', 'token=' . $this->session->data['token'], true);

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=payment', true);

		if (isset($this->request->post['cryptexy_api_key'])) {
			$data['cryptexy_api_key'] = $this->request->post['cryptexy_api_key'];
		} else {
			$data['cryptexy_api_key'] = $this->config->get('cryptexy_api_key');
		}

		if (isset($this->request->post['cryptexy_debug'])) {
			$data['cryptexy_debug'] = $this->request->post['cryptexy_debug'];
		} else {
			$data['cryptexy_debug'] = $this->config->get('cryptexy_debug');
		}

		if (isset($this->request->post['cryptexy_total'])) {
			$data['cryptexy_total'] = $this->request->post['cryptexy_total'];
		} else {
			$data['cryptexy_total'] = $this->config->get('cryptexy_total');
		}

		if (isset($this->request->post['cryptexy_completed_status_id'])) {
			$data['cryptexy_completed_status_id'] = $this->request->post['cryptexy_completed_status_id'];
		} else {
			$data['cryptexy_completed_status_id'] = $this->config->get('cryptexy_completed_status_id');
		}


		if (isset($this->request->post['cryptexy_less_status_id'])) {
			$data['cryptexy_less_status_id'] = $this->request->post['cryptexy_less_status_id'];
		} else {
			$data['cryptexy_less_status_id'] = $this->config->get('cryptexy_less_status_id');
		}

		if (isset($this->request->post['cryptexy_more_status_id'])) {
			$data['cryptexy_more_status_id'] = $this->request->post['cryptexy_more_status_id'];
		} else {
			$data['cryptexy_more_status_id'] = $this->config->get('cryptexy_more_status_id');
		}

		if (isset($this->request->post['cryptexy_failed_status_id'])) {
			$data['cryptexy_failed_status_id'] = $this->request->post['cryptexy_failed_status_id'];
		} else {
			$data['cryptexy_failed_status_id'] = $this->config->get('cryptexy_failed_status_id');
		}

		if (isset($this->request->post['cryptexy_pending_status_id'])) {
			$data['cryptexy_pending_status_id'] = $this->request->post['cryptexy_pending_status_id'];
		} else {
			$data['cryptexy_pending_status_id'] = $this->config->get('cryptexy_pending_status_id');
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['cryptexy_geo_zone_id'])) {
			$data['cryptexy_geo_zone_id'] = $this->request->post['cryptexy_geo_zone_id'];
		} else {
			$data['cryptexy_geo_zone_id'] = $this->config->get('cryptexy_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['cryptexy_status'])) {
			$data['cryptexy_status'] = $this->request->post['cryptexy_status'];
		} else {
			$data['cryptexy_status'] = $this->config->get('cryptexy_status');
		}

		if (isset($this->request->post['cryptexy_sort_order'])) {
			$data['cryptexy_sort_order'] = $this->request->post['cryptexy_sort_order'];
		} else {
			$data['cryptexy_sort_order'] = $this->config->get('cryptexy_sort_order');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/payment/cryptexy', $data));
	}
    public function install() {
        $this->load->model('localisation/order_status');
        $this->load->model('localisation/language');


        $langs = $this->model_localisation_language->getLanguages();

        $default_params = array();

        $i = 0;

        foreach ($langs as $lang) {

            $this->model_localisation_order_status->addOrderStatus(array(
                'order_status' => array(
                    $lang['language_id'] => array('name' => 'Cryptexy: Полная оплата')
                )
            ));

            if ($i == 0) $default_params['cryptexy_completed_status_id'] = $this->db->getLastId();

            $this->model_localisation_order_status->addOrderStatus(array(
                'order_status' => array(
                    $lang['language_id'] => array('name' => 'Cryptexy: Неполная оплата')
                )
            ));

            if ($i == 0) $default_params['cryptexy_less_status_id'] = $this->db->getLastId();

            $this->model_localisation_order_status->addOrderStatus(array(
                'order_status' => array(
                    $lang['language_id'] => array('name' => 'Cryptexy: Переплата')
                )
            ));

            if ($i == 0) $default_params['cryptexy_more_status_id'] = $this->db->getLastId();

            $i++;
        }

        $this->load->model('setting/setting');

        $this->model_setting_setting->editSetting('cryptexy', $default_params);
    }

    public function uninstall() {
        $this->load->model('localisation/order_status');

        $this->load->model('localisation/language');

        $this->load->model('setting/setting');

        $this->model_setting_setting->deleteSetting('cryptexy');

        $this->db->query("DELETE FROM " . DB_PREFIX . "order_status WHERE name = 'Cryptexy: Полная оплата' ");

        $this->db->query("DELETE FROM " . DB_PREFIX . "order_status WHERE name = 'Cryptexy: Неполная оплата' ");

        $this->db->query("DELETE FROM " . DB_PREFIX . "order_status WHERE name = 'Cryptexy: Переплата' ");

    }

	private function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/cryptexy')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['cryptexy_api_key']) {
			$this->error['api_key'] = $this->language->get('error_api_key');
		}

		return !$this->error;
	}

    public function clearLog() {
        $json = array();
        $this->load->language('extension/payment/cryptexy');
        if ($this->validatePermission()) {
            if (is_file(DIR_LOGS . 'cryptexy.log')) {
                @unlink(DIR_LOGS . 'cryptexy.log');
            }
            $json['success'] = $this->language->get('text_clear_log_success');
        } else {
            $json['error'] = $this->language->get('error_permission');
        }

        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($json));
    }

    protected function validatePermission() {
        return $this->user->hasPermission('modify', 'extension/payment/cryptexy');
    }

    protected function readLastLines($filename, $lines) {
        if (!is_file($filename)) {
            return array();
        }
        $handle = @fopen($filename, "r");
        if (!$handle) {
            return array();
        }
        $linecounter = $lines;
        $pos = -1;
        $beginning = false;
        $text = array();

        while ($linecounter > 0) {
            $t = " ";

            while ($t != "\n") {
                /* if fseek() returns -1 we need to break the cycle*/
                if (fseek($handle, $pos, SEEK_END) == -1) {
                    $beginning = true;
                    break;
                }
                $t = fgetc($handle);
                $pos--;
            }

            $linecounter--;

            if ($beginning) {
                rewind($handle);
            }

            $text[$lines - $linecounter - 1] = fgets($handle);

            if ($beginning) {
                break;
            }
        }
        fclose($handle);

        return array_reverse($text);
    }
}